package src.elandToCoord;

import java.io.FileWriter;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import src.lib.CoordHitPlus;
import src.lib.CoordIterator;

/**
 * Should seperate a coord file based on chromosome!
 * 
 * output is <chr>.part.coord
 * The "part" portion can be overwritten with an option command line argument. 
 * 
 * @author matthewb
 *
 */

public class SeparateReads
{

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception
	{
		// TODO Auto-generated method stub
		
		
		if(args.length < 2)
		{
			System.out.println("usage: <coord file> <output path/> [name]");
			System.exit(-1);	
		}
		
		Hashtable <String,FileWriter> ht = new Hashtable <String,FileWriter>(40);
		Hashtable <String,int[]> cntht = new Hashtable <String,int[]>(40);
		CoordIterator ci = new CoordIterator(args[0]);
		String output_path = args[1];
		String ex_name = "part";
		if(args.length > 2)
			ex_name = args[2];
		int cnt = 0;
		while(ci.hasNext())
		{
			cnt++;
			if(cnt%10000 == 0) System.out.print(".");
			Vector<CoordHitPlus> chp = ci.next();
			if(chp.size() != 1)
				throw new Exception("Found more than 1 entry for read.  This program assumes there is only 1 (best hit) per read!");
			CoordHitPlus curr = chp.elementAt(0);
			String chrname = curr.seqName;
			chrname = chrname.replace('>', ' ');
			chrname = chrname.trim();
			FileWriter fw = ht.get(chrname);//seqName = chrname!
			int[] I = cntht.get(chrname);
			if(fw == null)
			{
				fw = new FileWriter(output_path + chrname+"."+ex_name+".coord");
				ht.put(chrname, fw);
				I = new int[1];
				cntht.put(chrname,I);
			}
			I[0]++;
			fw.write(curr.outString()+"\n");
			
		}
		Enumeration<String> keys = ht.keys();
		System.out.println("\nFound "+cnt+" records.");
		while(keys.hasMoreElements())
		{
			String key = keys.nextElement();
			int[] I = cntht.get(key);
			System.out.println(key+":"+I[0]);
			FileWriter fw = ht.get(key);
			fw.close();
		}
		
		
		

	}

}
