package src.lib;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Iterator;
import java.util.Vector;

public class CoordIterator implements Iterator {
	
	public static String SVNID = "$Id: CoordIterator.java 31738 2007-08-22 22:11:00Z afejes $";
	
	BufferedReader br;
	CoordHitPlus curr;

	public CoordIterator(String file) throws Exception {
		br = new BufferedReader(new FileReader(file));
		String line = br.readLine();
		if (line == null) {
			curr = null;
		}
		curr = new CoordHitPlus(line);
	}

	public boolean hasNext() {
		return curr != null;
	}

	public Vector<CoordHitPlus> next() {
		Vector<CoordHitPlus> v = new Vector<CoordHitPlus>(80);
		v.add(curr);
		for (;;) {
			String l = null;
			try {
				l = br.readLine();
			} catch (Exception e) {
				System.out.println("exceptiopn! " + e);
				curr = null;
				return v;
			}
			if (l == null) {
				curr = null;
				return v;
			}
			CoordHitPlus c = null;
			try {
				c = new CoordHitPlus(l);
			} catch (Exception e) {
				System.out.println("Error with line:" + l);
				curr = null;
			}
			if (!c.queryName.equals(curr.queryName)) {
				curr = c;
				return v;
			}
			v.add(c);
		}

	}

	/**
	 * @deprecated by Anthony Fejes - this function does nothing
	 */
	public void remove() {

	}

	public static CoordHitPlus getBestP(Vector<CoordHitPlus> v) {
		if (v == null) { 
			return null;
		}
		if (v.size() == 0) {
			return null;
		}
		CoordHitPlus ch = v.elementAt(0);
		for (int i = 1; i < v.size(); i++) {
			if (v.elementAt(i).P < ch.P) {
				ch = v.elementAt(i);
			}
		}
		return ch;
	}

	public static CoordHitPlus getBestPositives(Vector<CoordHitPlus> v) {
		if (v == null) {
			return null;
		}
		if (v.size() == 0) {
			return null;
		}
		CoordHitPlus ch = v.elementAt(0);
		for (int i = 1; i < v.size(); i++) {
			if (v.elementAt(i).positive > ch.positive) {
				ch = v.elementAt(i);
			}
		}
		return ch;
	}

	public static CoordHitPlus getBestScore(Vector<CoordHitPlus> v) {
		if (v == null) {
			return null;
		}
		if (v.size() == 0) {
			return null;
		}
		CoordHitPlus ch = v.elementAt(0);
		for (int i = 1; i < v.size(); i++) {
			if (v.elementAt(i).score > ch.score) {
				ch = v.elementAt(i);
			}
		}
		return ch;
	}

}
